# Copyright 2022-present Lenovo
# Confidential and Proprietary

import os
from glob import glob
import json

from dataset_analysis import DatasetAnalysisBase


class DatasetAnalysis(DatasetAnalysisBase):
    def verify_format(self, dataset_path):
        input_fname_pattern = self.get_file_type(os.path.join(dataset_path))
        if len(input_fname_pattern) < 3:
            print('[ERROR]: There are no valid image files '
                  'in {}'.format(dataset_path))
            exit(1)
        image_set = glob(os.path.join(dataset_path, input_fname_pattern))
        sample_num = len(image_set)

        self.check_empty_dataset(dataset_path, sample_num)
        size = self.get_dir_size_b(dataset_path)
        return {
            "size_b": size,
            "label_num": -1,
            "sample_num": sample_num,
            "label_statistics": json.dumps({
                "Size": size,
                "Samples": sample_num
            })
        }
