# Copyright 2018-present Lenovo
# Confidential and Proprietary

import tensorflow.compat.v1 as tf
tf.disable_v2_behavior()
from factory import create_app

if __name__ == 'deploy_service':
    gun_args = ['workers', 'bind', 'pythonpath', 'access-logfile',
                'error-logfile', 'env', 'timeout']
    for param in gun_args:
        tf.app.flags.DEFINE_string(param, '', '')
    inf_app = create_app()


if __name__ == '__main__':
    tf.app.flags.DEFINE_enum(
        'scenario', 'classification',
        ['classification', 'objectdetection', 'segmentation', 'text'],
        "Scenario for this service"
    )
    tf.app.flags.DEFINE_string(
        'url', '/api/service', 'URL used to access the deployed service'
    )
    tf.app.flags.DEFINE_string('deploy_path', '', "deploy service path")
    tf.app.flags.DEFINE_string(
        'lico_model_path', '', "model path, for inference job"
    )
    tf.app.flags.DEFINE_string(
        'lico_image_file', '', "image file to deal, for inference job"
    )
    tf.app.flags.DEFINE_string(
        'lico_output_dir', '', "output dir, for inference job"
    )
    tf.app.flags.DEFINE_string('model_name', '',
                               "model_name of the deployed service")
    tf.app.flags.DEFINE_integer(
        'port', 60000, 'HTTP server port for the deployed service'
    )
    tf.app.flags.DEFINE_string(
        'service_uuid', '',
        'Deployed service which would be add to URI'
    )
    tf.app.flags.DEFINE_integer('lico_text_max_seq_length', 256,
                                "text for max_seq_length")
    tf.app.flags.DEFINE_enum('lico_text_language', 'en',
                             ['en', 'zh'], 'text for language')
    tf.app.flags.DEFINE_boolean('lico_text_lower_case', True,
                                "text for do_lower_case")
    FLAGS = tf.app.flags.FLAGS

    from os.path import dirname
    from subprocess import check_call

    cmd = [
        'gunicorn',
        '--workers',
        '1',
        '--bind',
        '0.0.0.0:{0}'.format(FLAGS.port),
        '--pythonpath',
        dirname(__file__),
        '--access-logfile',
        '-',
        '--error-logfile',
        '-',
        '--timeout',
        '600',
        '--env',
        'LETRAIN_SCENARIO={0}'.format(FLAGS.scenario),
        '--env',
        'LETRAIN_MODEL_PATH={0}'.format(FLAGS.deploy_path),
        '--env',
        'LETRAIN_MODEL_NAME={0}'.format(FLAGS.model_name),
        '--env',
        'SERVICE_UUID={0}'.format(FLAGS.service_uuid),
        '--env',
        'SERVICE_URL={0}'.format(FLAGS.url),
        '--env',
        'TEXT_MAX_SEQ_LENGTH={0}'.format(FLAGS.lico_text_max_seq_length),
        '--env',
        'TEXT_LANGUAGE={0}'.format(FLAGS.lico_text_language),
        '--env',
        'TEXT_LOWER_CASE={0}'.format(FLAGS.lico_text_lower_case),
        'deploy_service:inf_app'
    ]
    check_call(cmd)
