# Copyright 2022-present Lenovo
# Confidential and Proprietary
import sys

import tensorflow.compat.v1 as tf
tf.disable_v2_behavior()
from export_model import BaseExportService
from tensorflow.saved_model import tag_constants
from tensorflow.saved_model.signature_def_utils import predict_signature_def

sys.path.append('/opt/letrain/engine')
sys.path.append('/opt/letrain/applications')
sys.path.append('/opt/letrain/applications/ehealth_unet')
from unet import Unet

FLAGS = tf.app.flags.FLAGS

VERSIONCONTROLL = FLAGS.lico_version_control


class ExportService(BaseExportService):
    def checkpoint2pb(self):
        graph = tf.Graph()
        with graph.as_default():
            Input_channels = 1
            Nb_classes = 2
            net = Unet(
                channels=Input_channels,
                n_class=Nb_classes,
                cost_kwargs=dict(class_weights=[1, 3]),
                layers=5,
                features_root=32
            )
            ckpt_path = tf.train.latest_checkpoint(FLAGS.lico_checkpoint_dir)

            saver = tf.train.Saver()
            with tf.Session() as sess:
                # Create a saver.
                sess.run(tf.local_variables_initializer())
                sess.run(tf.global_variables_initializer())

                # Restore variables from disk.
                saver.restore(sess, ckpt_path)
                export_path = self.get_export_path(
                    FLAGS.lico_pb_path,
                    VERSIONCONTROLL,
                    FLAGS.model_version
                )
                builder = tf.saved_model.builder.SavedModelBuilder(export_path)
                signature = predict_signature_def(
                    inputs={'input': net.x, 'prob': tf.placeholder(tf.float32)},
                    outputs={'output': net.predicter}
                )
                builder.add_meta_graph_and_variables(
                    sess=sess,
                    tags=[tag_constants.SERVING],
                    signature_def_map={'predict': signature}
                )
                builder.save()
        self.package_model_into_zip_file(FLAGS.lico_pb_path, export_path)


if __name__ == '__main__':
    med_obj = ExportService()
    med_obj.checkpoint2pb()
