# Copyright 2022-present Lenovo
# Confidential and Proprietary
import os
import sys
import tensorflow.compat.v1 as tf
tf.disable_v2_behavior()

from tensorflow.saved_model.signature_def_utils import predict_signature_def

letrain_path = "/opt/letrain"
path_list = [os.path.join(letrain_path, 'applications'),
             os.path.join(letrain_path, 'applications/bert_qc'),
             letrain_path,
             letrain_path + 'lib',
             letrain_path + 'engine',
             letrain_path + 'inference',
             letrain_path + 'applications',
             os.path.join(letrain_path, "applications/bert_qc"),
             os.path.join(letrain_path, "applications/frcnn/lib/utils"),
             os.path.join(letrain_path, "inference/bert_qc")]
sys.path += path_list

from export_model import BaseExportService
from core.get_examples import UniformProcessor
from core.modeling import BertModel, BertConfig

tf.app.flags.DEFINE_bool('inference', True, "")
tf.app.flags.DEFINE_string('language', '', """ language """)

FLAGS = tf.app.flags.FLAGS
import tf_slim as slim  # noqa: F401
tf.logging.set_verbosity(tf.logging.INFO)

VOCAB_FILE = "/opt/pretrain_models/bert_qc/{}/vocab.txt".\
    format(FLAGS.lico_text_language)
BERT_CONFIG_FILE = \
    "/opt/pretrain_models/bert_qc/{}/bert_config.json".\
    format(FLAGS.lico_text_language)
VERSIONCONTROLL = FLAGS.lico_version_control


class ExportService(BaseExportService):
    def checkpoint2pb(self):
        graph = tf.Graph()

        with graph.as_default():
            # need data_direct
            bert_config = BertConfig.from_json_file(BERT_CONFIG_FILE)

            input_ids = tf.placeholder(
                tf.int32,
                (None, FLAGS.lico_text_max_seq_length),
                'input_ids'
            )
            input_mask = tf.placeholder(
                tf.int32,
                (None, FLAGS.lico_text_max_seq_length),
                'input_mask'
            )

            processor = UniformProcessor()
            label_list = processor.read_labels(FLAGS.lico_checkpoint_dir)
            num_labels = len(label_list)

            model = BertModel(
                config=bert_config,
                is_training=False,
                input_ids=input_ids,
                input_mask=input_mask,
                token_type_ids=None,
                use_one_hot_embeddings=False)

            output_layer = model.get_pooled_output()

            hidden_size = output_layer.shape[-1].value

            output_weights = tf.get_variable(
                "output_weights", [num_labels, hidden_size],
                initializer=tf.truncated_normal_initializer(stddev=0.02))

            output_bias = tf.get_variable(
                "output_bias", [num_labels], initializer=tf.zeros_initializer())

            output_layer = tf.nn.dropout(output_layer, keep_prob=0.9)

            logits = tf.matmul(output_layer, output_weights, transpose_b=True)
            logits = tf.nn.bias_add(logits, output_bias)
            probabilities = tf.nn.softmax(logits, axis=-1)
            log_probs = tf.nn.log_softmax(logits, axis=-1)
            print(probabilities)

            ckpt_path = tf.train.latest_checkpoint(FLAGS.lico_checkpoint_dir)

            saver = tf.train.Saver()
            with tf.Session() as sess:
                # Create a saver.
                sess.run(tf.local_variables_initializer())
                sess.run(tf.global_variables_initializer())

                # Restore variables from disk.
                saver.restore(sess, ckpt_path)
                export_path = self.get_export_path(
                    FLAGS.lico_pb_path,
                    VERSIONCONTROLL,
                    FLAGS.model_version
                )
                builder = tf.saved_model.builder.SavedModelBuilder(export_path)

                signature = predict_signature_def(
                    inputs={
                        'input_ids': input_ids,
                        'input_mask': input_mask
                    },
                    outputs={
                        'output_logits': logits,
                        'output_log_probs': log_probs
                    }
                )

                builder.add_meta_graph_and_variables(
                    sess=sess,
                    tags=[tf.saved_model.tag_constants.SERVING],
                    signature_def_map={'predict': signature}
                )
                builder.save()
        self.package_model_into_zip_file(FLAGS.lico_pb_path, export_path)


if __name__ == '__main__':
    od_obj = ExportService()
    od_obj.checkpoint2pb()
